﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;

namespace BiblioPhone
{
    public partial class MainPage : PhoneApplicationPage
    {
        BibliotecaService.BibliotecaServiceClient serveiBiblio = new BibliotecaService.BibliotecaServiceClient();
        // Constructor
        public MainPage()
        {
            InitializeComponent();
            VariablesGlobals.usuari.autentificat = false;
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
           // errorMessage.Text = String.Empty;
            try
            {
                try
                {
                    serveiBiblio.LoginAsync((string)userNameBox.Text, (string)passwordBox.Password);
                    serveiBiblio.LoginCompleted+= new EventHandler<BibliotecaService.LoginCompletedEventArgs>(client_getStringCompleted);
                    //if (VariablesGlobals.usuari.nomUsuari != null)
                    //{
                    //System.Threading.Thread.Sleep(5000);

                        /*
                        */
                        //System.Threading.Thread.Sleep(5000);
                        //
                        //
                   //}
                    //else
                   // {
                   //     errorMessage.Text = "Usuari o Password incorrectes";
                    //}
                }
                catch
                {
                    errorMessage.Text = "Error conectant amb el servei";
                    return;
                }

            }
            catch (Exception ex)
            {
                errorMessage.Text = "Error conectant amb el servei";
                return;
            }
        }


       private void client_getStringCompleted (object sender, BibliotecaService.LoginCompletedEventArgs e)
        {

            if (e.Error != null)
            {
                MessageBox.Show(e.Error.Message);
            }
            else
            {
                if (e.Result != 0)
                {
                    VariablesGlobals.usuari.nomUsuari = (string)userNameBox.Text;
                    VariablesGlobals.usuari.password = (string)passwordBox.Password;
                    errorMessage.Text = VariablesGlobals.usuari.nomUsuari + VariablesGlobals.usuari.password;
                    serveiBiblio.GetUsuariPhonev2Async(VariablesGlobals.usuari.nomUsuari, VariablesGlobals.usuari.password);
                    serveiBiblio.GetUsuariPhonev2Completed += new EventHandler<BibliotecaService.GetUsuariPhonev2CompletedEventArgs>(getUsuariCompleted);
                }
                else
                {
                    VariablesGlobals.usuari.nomUsuari = null;
                    VariablesGlobals.usuari.password = null;
                    errorMessage.Text = "Nom d'usuari o password incorrectes";
                }
            }
        }

       private void getUsuariCompleted (object sender, BibliotecaService.GetUsuariPhonev2CompletedEventArgs e)
       {
            if (e.Error != null)
            {
                MessageBox.Show(e.Error.Message);
            }
            else
            {
                VariablesGlobals.perfilUsuari = null;
                if (e.Result != null)
                {
                    errorMessage.Text = "Dades d'usuari";
                    VariablesGlobals.perfilUsuari = e.Result;
                    serveiBiblio.GetPrestecsPhoneAsync(VariablesGlobals.usuari.nomUsuari, VariablesGlobals.usuari.password);
                    serveiBiblio.GetPrestecsPhoneCompleted += new EventHandler<BibliotecaService.GetPrestecsPhoneCompletedEventArgs>(getPrestecsCompleted);
                }
                else
                {
                    errorMessage.Text = "No hi ha informació de l'usuari";
                }
            }
       }

       private void getPrestecsCompleted(object sender, BibliotecaService.GetPrestecsPhoneCompletedEventArgs e)
       {

            if (e.Error != null)
            {
                MessageBox.Show(e.Error.Message);
            }
            else
            {
                VariablesGlobals.llistaPrestecs.Clear();
                if (e.Result != null)
                {
                    VariablesGlobals.llistaPrestecs = e.Result.ToList();
                    VariablesGlobals.llibresString.Clear();
                    foreach (BibliotecaService.Prestec p in VariablesGlobals.llistaPrestecs)
                    {
                        VariablesGlobals.llibresString.Add(p.TitolLlibre + " - " + p.DataEstimada.ToShortDateString());
                    }
                    NavigationService.Navigate(new Uri("/perfil.xaml", UriKind.Relative));
                }
                else 
                {
                    errorMessage.Text = "Null";
                }
            }
        }

    }
}           
